This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 457090 - dhcp should not be removing static routes
dhcp should not be removing static routes
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: dhcp (Show other bugs)
9
All Linux
low Severity low
: ---
: ---
Assigned To: David Cantrell
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-07-29 11:34 EDT by Steve Whitehouse
Modified: 2014-06-09 07:07 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 13:51:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Network config files (917 bytes, application/x-compressed-tar)
2008-09-29 10:40 EDT, Steve Whitehouse
no flags Details

  None (edit)
Description Steve Whitehouse 2008-07-29 11:34:32 EDT
When adding routes, dhcp should not remove any existing static routes. It should
only remove kernel routes, and those which it has added itself.

This causes problems when with a static default route which is getting removed
when it ought not to be.
Comment 1 David Cantrell 2008-09-26 18:06:51 EDT
I am unable to recreate this locally.  Can you give me details on what your setup looks like so I can try to reproduce it locally and work on a fix?
Comment 2 Steve Whitehouse 2008-09-29 10:40:53 EDT
Created attachment 317988 [details]
Network config files

Please find attached my network config files.

The problem is that when bond0.5 is started (currently started manually due to this problem!), dhcp rewrites the default route despite the fact that (see route-bond0.6) it is marked static.

dhcp should not be removing routes unless (a) they are kernel routes, or (b) they were added by dhcp itself.
Comment 3 David Cantrell 2008-10-20 23:29:31 EDT
Sorry for the late reply.  It's been quite busy with the end of F-10 and RHEL 5.3 in the works.

Let me make sure I understand your configuration correctly...
You've only got one bond interface that is configured via DHCP.  The others are static.  The DHCP controlled interface should not be driving over your default route, which is already set by one of the other interfaces.  Is this correct?

If that's the case, what happens when you add

    GATEWAYDEV=bond0.6

to the ifcfg-bond0.5 file?
Comment 4 Steve Whitehouse 2008-10-21 04:33:47 EDT
Yes, my configuration is as you suggest. The only reason I'm using dhcp is because I have a Cisco PIX which I use for access to the Red Hat VPN and dhcp is the only option which works in that case.

Now adding GATEWAYDEV would not solve the problem, and in fact it creates a new one. The problem is that dhcp should not be removing static routes since it is basically a dynamic routing system, like any other. Also GATEWAYDEV would add kernel routes, not static routes which is why I never use that feature in the first place. Its much easier just to set the routes using the route-* files where required and then you get full control over what is going on.

Either way though, dhcp should not be changing routes which are marked static, it should only be touching those it added itself, or those which are marked kernel. That should apply to any route, not just the default route which happens to be the problem here.
Comment 5 David Cantrell 2008-10-21 19:27:07 EDT
All of the routing setup for dhclient is handled by /sbin/dhclient-script.  And here are all of the lines in F-9 that add/change routing table entries:

198:             /sbin/ip route add ${router}/32 dev $interface
221:        /sbin/ip route replace default via $router dev $interface $metric
265:            /sbin/ip route replace ${new_network_number}/${prefix_bits} dev $interface
267:                /sbin/ip route del default
299:                /sbin/ip route replace default via $GATEWAY dev $interface
328:                    /sbin/ip route replace ${target}/$(class_bits $target) via ${gateway} dev $interface ${metric}
343:        /sbin/ip route replace ${alias_ip_address}/32 dev $interface:0
473:        /sbin/ip route replace default dev $interface && added_old_broadcast_route=1
557:        /sbin/ip route replace ${alias_ip_address}/32 $interface:0

Have you tried DHCLIENT_IGNORE_GATEWAY=yes in ifcfg-bond0.5?
Comment 6 David Cantrell 2008-10-30 21:12:19 EDT
Have not heard anything back since comment #5.
Comment 7 Steve Whitehouse 2008-10-31 05:18:45 EDT
Please do not close this. The machine in question is being used as my main email/dns/everything box atm, so I'm trying to find a moment to do the test on another machine.
Comment 8 David Cantrell 2008-11-01 00:29:13 EDT
For my own status tracking purposes, I'm going to flag this as needinfo since I'm waiting on additional information.
Comment 9 Bug Zapper 2009-06-09 22:17:05 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2009-07-14 13:51:39 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 11 Steve Whitehouse 2014-06-09 07:07:43 EDT
Clearing needinfo, since someone is now running a script that generates email from needinfo flags :(

Note You need to log in before you can comment on or make changes to this bug.